from osv import fields, osv
from product_builder import product_builder

class product_product(osv.osv):
    _inherit = 'product.product'

    def _create_builder(self, lines):
        """ Create a product builder that will combine grouped lines of products
        into single lines.
        
        Use builder.input_lines to add calculated fields before grouping, and
        then call builder.combine() to combine them. See the product_builder 
        class for more details.
        """
        return product_builder(lines)

product_product()

class product_category(osv.osv):
    _inherit = 'product.category'

    _columns = {
        'append_with': fields.char(
            'Allow appending products like',
            size=255,
            help='Comma-separated list of patterns for product codes that can '
                'be appended to this category\'s products in a group. Use "_" to '
                'match any single character, and "%" to match any group of '
                'characters. For example, "PMF3, KT%".')
    }

product_category()
