from osv import fields, osv
import pooler
from tools.translate import _

class account_invoice(osv.osv):
    _inherit = 'account.invoice'

    def _prepare_line_to_combine(self, line):
        """ Prepare an invoice line before it gets combined. """
        pass

    def _prepare_product_builder(self, builder):
        """ Configure product builder with fields to match, copy, etc. """
        builder.add_fields_to_match(['invoice_line_tax_id', 
                                     'quantity', 
                                     'uos_id', 
                                     'discount'])
        builder.add_fields_to_sum(['price_unit', 'price_subtotal'])
        builder.add_fields_to_concatenate(['note'])

    def _combined_lines(self, invoice):
        """ Combine the invoice lines according to grouping. """
        product_obj = self.pool.get('product.product')
        
        builder = product_obj._create_builder(invoice.invoice_line)
        self._prepare_product_builder(builder)
        for line in builder.input_lines:
            self._prepare_line_to_combine(line)
        
        combined_lines = builder.combine()
        if builder.warnings:
            raise osv.except_osv(_('Invalid grouping!'), builder.warnings)
        
        return combined_lines

account_invoice()

class account_invoice_line(osv.osv):
    _inherit = 'account.invoice.line'
    _order = 'grouping, id'

    _columns = {
        'grouping': fields.char(
            'Grouping',
            size=20,
            help='Used to sort line items alphabetically and group them. '
                'Before the period is the group name, the suffix orders within '
                'a group.'),
    }

account_invoice_line()
