import pooler
from report import report_sxw

class picking(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context, *args, **kwargs):
        super(picking, self).__init__(cr, uid, name, context, *args, **kwargs)
        self.localcontext.update({
            'format_quantity_digits': self.format_quantity_digits,
            'number_is_int': lambda x: int(x) == x,
            'combined_lines': self.combined_lines,
            'get_qtytotal': self._get_qtytotal
        })
        #Record that this report was printed.
        pooler.get_pool(cr.dbname).get('stock.picking').write(
            cr,
            uid,
            context['active_ids'],
            {'checklist_printed': True})

    def format_quantity_digits(self,line):
        import re
        rounding_str = str(line.product_uom.rounding)
        round_decimals = re.search('\.(.*[1-9])',rounding_str)
        decimals = 0
        if ( round_decimals ):
          decimals = len(round_decimals.group(1))
        return decimals
        
    def _get_qtytotal(self, picking):
        picking_obj = pooler.get_pool(self.cr.dbname).get('stock.picking')
        move_lines = picking_obj._combined_lines(picking)
        
        total = 0.0
        uom = move_lines[0].product_uom.name
        for move in move_lines:
            total += move.product_qty
        return {'quantity':total, 'uom':uom}

    def combined_lines(self, picking):
        picking_obj = pooler.get_pool(self.cr.dbname).get('stock.picking')
        return picking_obj._combined_lines(picking)

report_sxw.report_sxw('report.stock.picking.list.combined.lines',
                      'stock.picking',
                      'addons/combined_lines_stock/report/picking.rml',
                      parser=picking)
