from dateutil.relativedelta import relativedelta
from osv import fields,osv,orm
from tools import config
from tools.translate import _
import netsvc

AVAILABLE_EMAIL_FIELDS = [
    ('rcp', 'Receiver'),
    ('subject', 'Subject'),
    ('body', 'Body')
]

OPERATORS = [
    ('isEmpty',  'is Empty'),
    ('isNotEmpty', 'is not Empty'),
    ('contains', 'contains'),
    ('notContains', 'doesn\'t contain'),
    ('endsWith', 'ends with'),
    ('startsWith', 'starts with')
]

class mail_message(osv.osv):
    _inherit = "mail.message"
    
    def send(self, cr, uid, ids, auto_commit=False, context=None):
        ew_obj = self.pool.get('email.whitelist')
        ew_ids = list()
        for message in self.browse(cr, uid, ids, context=context):
            if ew_obj.check_whitelist(cr, uid, ids, message):
            # email passed whitelist, add it to send list
                ew_ids.append(message['id'])
            else:
            # email contain un-whitelist items, cancel it
                message.write({'state':'cancel'})
        return super(mail_message,self).send(cr, uid, ew_ids, auto_commit, context)


class email_whitelist(osv.osv):
    _name = 'email.whitelist'
    _columns = {
      'field': fields.selection(AVAILABLE_EMAIL_FIELDS, 'Field'),
      'op': fields.selection(OPERATORS, 'Comparator'),
      'value': fields.text('Value')
    }
    
    def check_whitelist(self, cr, uid, ids, msg, context=None):
        """
        Parses the user inputs and return a true or false
        if the email passes the whitelist or not.
        """
        
        if context is None:
            context = {}
        ew_ids = self.search(cr, uid, [])
        if not ew_ids:
            # No whitelists, send nothing
            return False
            
        # starting whitelists checking"
        ew_msg = dict()  
        
        for ew in self.browse(cr,uid,ew_ids,context):
            if ew.field != "rcp":
                if ew.field == "body":
                    if msg.body_text:
                        param = "body_text"
                    else:
                        param = "body_html"
                else:
                    param = ew.field
                if eval('self.'+ew.op+'("""'+msg[param]+'""", "'.strip()+ew.value+'")'):
                    continue
                else:
                    return False
            else:
                tags = ['email_to', 'email_cc', 'email_bcc', 'reply_to']
                for tag in tags:
                    if not msg[tag]: continue
                    for r in msg[tag].split(','):
                        if not eval('self.'+ew.op+'("'+r.strip()+'", "'+ew.value+'")') and r.strip():
                        # found a recipient not in whitelist, cancel email
                            return False
        return True
        
    def isEmpty(self, string, value):
        if string:
            return False
        else: 
            return True
            
    def isNotEmpty(self, string, value):
        return not self.isEmpty(string, value)
            
    def contains(self, string, value):
        if string.lower().find(value.lower()) > -1:
            return True
        else: 
            return False
            
    def notContains(self, string, value):
        return not self.contains(string, value)
            
    def endsWith(self, string, value):
        return string.lower().endswith(value.lower())
        
    def startsWith(self, string, value):
        return string.lower().startswith(value.lower())
        
email_whitelist()
