from osv import fields
from osv import osv

from mx import DateTime

class hr_timesheet_sheet(osv.osv):
    _inherit = 'hr_timesheet_sheet.sheet'

    def _default_date_from(self,cr, uid, context=None):
        user = self.pool.get('res.users').browse(cr, uid, uid, context)
        r = user.company_id and user.company_id.timesheet_range
        if r != 'semimonth':
            return super(hr_timesheet_sheet, self)._default_date_from(cr, 
                                                                      uid, 
                                                                      context)
        now = DateTime.now()
        if now.day <= 15:
            return now.strftime('%Y-%m-01')
        return now.strftime('%Y-%m-16')

    def _default_date_to(self,cr, uid, context=None):
        user = self.pool.get('res.users').browse(cr, uid, uid, context)
        r = user.company_id and user.company_id.timesheet_range
        if r != 'semimonth':
            return super(hr_timesheet_sheet, self)._default_date_to(cr, 
                                                                    uid, 
                                                                    context)
        now = DateTime.now()
        if now.day <= 15:
            return now.strftime('%Y-%m-15')
        return (now + DateTime.RelativeDateTime(months=+1,
                                                day=1,
                                                days=-1)).strftime('%Y-%m-%d')    

    _defaults = {'date_from': _default_date_from,
                 'date_to': _default_date_to}

hr_timesheet_sheet()

class res_company(osv.osv):
    _inherit = 'res.company'
    _columns = {
        'timesheet_range': fields.selection([('day','Day'),
                                             ('week','Week'),
                                             ('semimonth', 'Semimonthly'),
                                             ('month','Month'),
                                             ('year','Year')], 
                                            'Timesheet range'),
        'timesheet_max_difference': fields.float(
            'Timesheet allowed difference',
            help="Allowed difference in hours between the sign in/out and " +
                "the timesheet computation for one sheet. Set this to 0 if " +
                "you do not want any limit."),
    }
    _defaults = {
        'timesheet_range': lambda *args: 'month',
        'timesheet_max_difference': lambda *args: 0.0
    }

res_company()
