from osv import fields, osv

class res_partner_function(osv.osv):
    _name = 'res.partner.function'
    _description = 'Function of the contact'
    _columns = {
        'name': fields.char('Function Name', size=64, required=True),
        'code': fields.char('Code', size=8, required=True),
        'ref':fields.char('Notes', size=32,),
    }
    _order = 'name'
    _sql_constraints = [
        ('code_uniq', 'unique (code)', 'The Code of the Partner Function must be unique !')
    ]

class res_partner_address(osv.osv):
    _inherit = 'res.partner.address'
    
    _columns = {'function_id': fields.many2one('res.partner.function', 
                                               'Function', 
                                               size=64)}
