from datetime import date

def add_months(start_date, months):
    """ Add a given number of months to the date, and return the first day of
    that month.
    
    The logic is simplified if we assume the first day of the month, because we
    don't have to deal with questions like, "What's March 30 minus one month?"
    """
    return date(
        start_date.year + (start_date.month - 1 + months) / 12,
        (start_date.month - 1 + months) % 12 + 1,
        1)
