import netsvc
from osv import fields, osv

class stock_picking(osv.osv):
    _inherit = "stock.picking"
    
    _columns = {
        'production_ids' : fields.one2many(
            'mrp.production',
            'picking_id',
            'Production Orders')
    }
    
    def _check_procurements(self, cr, uid, ids, context=None):
        """ Run procurements for all stock moves.
        
        This is similar to action_assign, but that stopped working when the
        production order packings changed their work flow.
        """
        wf_service = netsvc.LocalService("workflow")
        for picking in self.browse(cr, uid, ids, context=context):
            for move in picking.move_lines:
                if move.state in ('waiting', 'confirmed'):
                    for proc in move.procurements:
                        wf_service.trg_validate(uid, 
                                                'procurement.order', 
                                                proc.id, 
                                                'button_check', 
                                                cr)
            
stock_picking()
