import time
import datetime

import netsvc
from osv import fields, osv
from tools.misc import DEFAULT_SERVER_DATETIME_FORMAT
from tools.translate import _

class change_production_qty(osv.osv_memory):
    _inherit = "change.production.qty"

    def change_prod_qty(self, cr, uid, ids, context=None):
        """ 
        Changes the Quantity of Product.
        @param self: The object pointer.
        @param cr: A database cursor
        @param uid: ID of the user currently logged in
        @param ids: List of IDs selected 
        @param context: A standard dictionary 
        @return:
        """
        record_id = context and context.get('active_id',False)
        assert record_id, _('Active Id is not found')
        prod_obj = self.pool.get('mrp.production')
        bom_obj = self.pool.get('mrp.bom')
        wf_service = netsvc.LocalService("workflow")
        
        for wiz_qty in self.browse(cr, uid, ids, context=context):
            prod = prod_obj.browse(cr, uid, record_id, context=context)

            # We need to know which direction this change is
            product_qty_new = wiz_qty.product_qty
            product_qty_old = prod.product_qty
            if product_qty_new == prod.product_qty:
                continue # no change in quantity, we don't need to do anything
            
            prod_obj.write(cr, uid,prod.id, {'product_qty': wiz_qty.product_qty})
            prod_obj.action_compute(cr, uid, [prod.id])
            
            wf_service.trg_validate(uid, 
                                    'mrp.production', 
                                    prod.id, 
                                    'button_recreate', 
                                    cr)
            
        return {}
