from osv import fields,osv

class crm_helpdesk(osv.osv):

    _inherit = 'crm.helpdesk'

    _columns = {
        'description': fields.text('Notes'), #relabel
        'history_ids': fields.one2many('mail.message', 
                                       'res_id', 
                                       'Messages', 
                                       domain=[('model', '=', 'crm.helpdesk'),
                                               ('subject', '=', 'Historize')]),
        'distributor_id': fields.many2one(
            'res.partner', 
            'Distributor',
            domain=[('category_id.name', '=', 'Distributor')]),
        'distributor_address_id': fields.many2one(
            'res.partner.address', 
            'Distributor Contact', 
            domain="[('partner_id', '=', distributor_id)]"),
    }

    def onchange_distributor_id(self, cr, uid, ids, distributor_id):
        """This function returns value of distributor address based on 
        distributor
        :param ids: List of case IDs
        :param part: Distributor's id
        """
        data={}
        if distributor_id:
            addr = self.pool.get('res.partner').address_get(cr, 
                                                            uid, 
                                                            [distributor_id], 
                                                            ['contact'])
            data = {'distributor_address_id': addr['contact']}
        return {'value': data}

crm_helpdesk()

class crm_entry_type(osv.osv):
    _name = "crm.entry.type"
    _description = "Entry Type"
    _columns = {
        'name': fields.char('Name',size=64, required=True, translate=True),
        'active': fields.boolean('Active'),
    }
    _defaults = {
        'active': lambda *a: 1,
    }

crm_entry_type()
