from osv import fields,osv
import tools

def format_date_tz(date, tz=None):
    if not date:
        return 'n/a'
    format = tools.DEFAULT_SERVER_DATETIME_FORMAT
    return tools.server_to_local_timestamp(date, format, format, tz)

class mail_message(osv.osv):
    _inherit = 'mail.message'

    def _get_display_text(self, cr, uid, ids, name, arg, context=None):
        if context is None:
            context = {}
        tz = context.get('tz')

        res = {}
        divider = '_' * 60
        for message in self.browse(cr, uid, ids):
            display = format_date_tz(message.date, tz)
            if message.body_text:
                display += '\n' + message.body_text
            else:
                display += ' ' + (message.subject or '')
            display += '\n' + divider
            res[message.id] = display
        return res
    
    def _get_res_name(self, cr, uid, ids, name, arg, context=None):
        model_map = {} # model name -> [res ids]
        message_map = {} # (model name, res id) -> [message ids]
        result = dict.fromkeys(ids)
        
        for message in self.browse(cr, uid, ids, context=context):
            res_ids = model_map.setdefault(message.model, [])
            res_ids.append(message.res_id)
            message_ids = message_map.setdefault(
                (message.model, message.res_id), 
                [])
            message_ids.append(message.id)
            
        for model, res_ids in model_map.iteritems():
            for res_id, name in self.pool.get(model).name_get(cr, 
                                                              uid, 
                                                              res_ids, 
                                                              context):
                message_ids = message_map[(model, res_id)]
                for message_id in message_ids:
                    result[message_id] = name
        return result
    
    _columns = {
        'display_text': fields.function(_get_display_text, 
                                        method=True, 
                                        type='text', 
                                        size="512", 
                                        string='Display Text'),
        'entry_type_id': fields.many2one('crm.entry.type', 'Entry Type'),
        'res_name': fields.function(_get_res_name,
                                    method=True,
                                    type='text',
                                    size='512',
                                    string='Related Document Name'),
    }
mail_message()
