from osv import fields,osv,orm

from property_filter import exclude_properties

class res_partner_category(osv.osv):

    def _description_short(self, cr, uid, ids, name, arg, context=None, max_length=15):
        """ Just return a shorted version of the string in the description if it runs on too long
        """
        result = {}
        for pcat in self.browse(cr, uid, ids, context=context):
            description = pcat.description
            if not description:
                result[pcat.id] = description
            else:
                shortened = description.partition('\n')[0]
                if ( len(shortened) < max_length ): 
                    result[pcat.id] = shortened 
                else:
                    result[pcat.id] = shortened[:max_length] + " ..."
        return result

    _inherit = 'res.partner.category'
    _columns = {
        'description': fields.text('Description'),
        'description_short': fields.function(_description_short,method=True,type='char',string='Description'),
    }

res_partner_category()

class res_partner(osv.osv):

    _inherit = 'res.partner'
    _columns = {
        'admin_user_id': fields.many2one(
             'res.users',
             'Dedicated Admin', 
             help='The internal user that is in charge of administrative ' +
                'tasks for this partner, if any.'),
    }
    
    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        filtered_fields = exclude_properties(self, fields, ids)
        return super(res_partner, self).read(cr, 
                                             uid, 
                                             ids, 
                                             fields=filtered_fields, 
                                             context=context, 
                                             load=load)

res_partner()

