from osv import fields

def exclude_properties(model_obj, field_names, ids):
    """ This helper method is a workaround for a bug in the GTK client that 
    makes it query all the detail fields for the whole list of search results. 
    If those detail fields include property fields, then it's really expensive, 
    so we filter out the property fields from the list. 
    To use this method, just call it from an override of the read method."""
    try:
        id_count = len(ids)
    except:
        id_count = 1
    if id_count <= 1 or not field_names:
        return field_names
    filtered_fields = []
    for field in field_names:
        field_info = model_obj._columns.get(field)
        if not field_info:
            inherit_info = model_obj._inherit_fields.get(field)
            field_info = inherit_info and inherit_info[2]
        if not isinstance(field_info, fields.property):
            filtered_fields.append(field)
    return filtered_fields
