from osv import fields,osv,orm


# Overloaded stock_picking to manage carriers :
class stock_picking(osv.osv):
    _name = "stock.picking"
    _inherit = 'stock.picking'
    _order = 'date desc'

    def _get_comment_invoice(self, cursor, user, picking):
        ''' Ensure that we only copy over the sales order note, not the
            picking note which is intended to be used internally
        '''
        if (picking.sale_id and picking.sale_id.note):
            return picking.sale_id.note
        return ''

stock_picking()

class stock_move(osv.osv):
    _inherit = 'stock.move'

    _columns = {'product_rack': fields.related('product_id', 
                                               'product_tmpl_id',
                                               'loc_rack', 
                                               type='char', 
                                               string='Rack', 
                                               store=False,
                                               readonly=True)}

    def create_chained_picking(self, cr, uid, moves, context=None):
        """ In OpenERP 5, only packing list moves were affected by chained
        locations. This method reproduces that by filtering for moves
        that have a picking_id. """
        
        picking_moves = [move for move in moves if move.picking_id]
        new_moves = super(stock_move, self).create_chained_picking(
            cr, 
            uid, 
            picking_moves, 
            context=context)
        return new_moves

stock_move()
