# -*- coding: utf-8 -*-
##############################################################################
#    
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
import mx.DateTime

DHM_FORMAT = '%Y-%m-%d %H:%M:%S'

class order(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(order, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'format_quantity_digits': self.format_quantity_digits,
            'partner_product_code': self.partner_product_code,
        })

    def format_quantity_digits(self,line):
        import re
        rounding_str = str(line.product_uom.rounding)
        round_decimals = re.search('\.(.*[1-9])',rounding_str)
        decimals = 0
        if ( round_decimals ):
          decimals = len(round_decimals.group(1))
        return decimals
    
    def partner_product_code ( self, line, partner ): 
    # This is where we try and figure out what product code this vendor uses to supply the
    # parts to us

    # If the product is something that's been manually added 
    # (no reference in the product.product table), we don't want to do any
    # special lookup
        if not line.product_id:
            return

    # Product exists in product.product, let's look 'er up
        self.cr.execute("SELECT product_code from product_supplierinfo \
            WHERE (product_id=%s) and (name=%s)", (line.product_id.id,partner.id))
        matches = self.cr.fetchall() or None
        if matches:
            return matches[0][0]
        return

report_sxw.report_sxw('report.purchase.order.zaber',
                      'purchase.order',
                      'addons/zaber_purchase/report/order.rml',
                      parser=order)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

