import math
import sys

from osv import osv
import pooler
from report import report_sxw

class order(report_sxw.rml_parse):
    def __init__(self, cr, uid, *args, **kwargs):
        super(order, self).__init__(cr, uid, *args, **kwargs)
        self.localcontext.update({
            'count_decimals': self.count_decimals,
            'combined_lines': self.combined_lines,
            'delay_days': self.delay_days,
        })
    
    def count_decimals(self, rounding):
        """ Count how many decimals should be used based on a rounding pattern.
        
        This module looks at the rounding pattern for the sales order line's
        unit of measure, and rounds the quantity to that level.
        """
        import re
        rounding_str = str(rounding)
        round_decimals = re.search('\.(.*[1-9])',rounding_str)
        decimals = 0
        if ( round_decimals ):
          decimals = len(round_decimals.group(1))
        return decimals

    def delay_days(self, delay):
        return int(math.ceil(delay))
    
    def combined_lines(self, order):
        order_obj = pooler.get_pool(self.cr.dbname).get('sale.order')
        return order_obj._combined_lines(order, shouldValidate=True)
    
report_sxw.report_sxw('report.sale.order.zaber', 
                      'sale.order', 
                      'addons/zaber_report_sale/report/sale_order.rml', 
                      parser=order, 
                      header="external")
