from osv import fields, osv

class sale_order(osv.osv):
    _inherit = 'sale.order'
            
    def _prepare_line_to_combine(self, line):
        """ Prepare a sales order line before it gets combined.
        
        Copy fields from related tables.
        """
        super(sale_order, self)._prepare_line_to_combine(line)
        promise_dates = [move.promise_date for 
            move in line.move_ids if 
            move.picking_id.state not in ('cancel', 'draft')]
        line.promise_date = promise_dates and max(promise_dates) or None
        if line.product_uos:
            line.rounding = line.product_uos.rounding
        else:
            line.rounding = line.product_uom.rounding

    def _prepare_product_builder(self, builder):
        """ Configure product builder with fields to match, copy, etc. """
        
        super(sale_order, self)._prepare_product_builder(builder)
        builder.add_fields_to_match(['rounding'])
        builder.add_fields_to_max(['promise_date'])

sale_order()
