from osv import osv, fields

class partner_account_statement(osv.osv_memory):
    _name = 'partner.account.statement'
    _description = 'Partner Account Statement'

    _columns = {'partner_id': fields.many2one('res.partner', 
                                              'Partner', 
                                              required=True),
                'number_paid_invoices': fields.integer(
                    'Number of Paid Invoices',
                    help='How many recently paid invoices for context?',
                    required=True)}
    
    _defaults = {'number_paid_invoices': lambda *a: 4}

    def generate(self, cr, uid, ids, context=None):
        for request in self.browse(cr, uid, ids):
            form = dict(number_paid_invoices=request.number_paid_invoices,
                        partner_id=request.partner_id.id)
            datas = {'ids': context.get('active_ids',[]),
                     'model': 'res.partner',
                     'form': form}
            return {'type': 'ir.actions.report.xml',
                    'report_name': 'zerp.account.statement',
                    'datas': datas}
        return {}
