from osv import fields, osv

class zerp_cheque(osv.osv_memory):
    _name = 'zerp.cheque'
    _description = 'ZERP Cheque'
    
    _columns = {'cheque_number': fields.integer(
                    'Cheque Number',
                    help='What number should the system assign this cheque?',
                    required=False),
                'cheque_note': fields.text(
                    'Cheque Note',
                    help='Notes that should be printed on the cheque stubs'),
                'cheque_date': fields.date(
                    'Cheque Date',
                    help='Date that should be printed on the cheque')}
    
    _defaults = {'cheque_date': fields.date.context_today}

    def create_cheque(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        data = self.read(cr, uid, ids)[0]
        datas = {'ids': context.get('active_ids',[]),
                 'model': 'account.invoice',
                 'form': data}
        return {'type': 'ir.actions.report.xml',
                'report_name': 'zerp.cheque',
                'datas': datas}

zerp_cheque()
