# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2013 Zaber Technologies Inc. (<http://www.zaber.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################


import tools
from osv import osv
from osv import fields
from tools.translate import _
from openerp import SUPERUSER_ID


class mail_message(osv.osv):
  _inherit = 'mail.message'

  def _section_id_fnct (self, cr, uid, ids, name, arg, context=None):
    context = context or {}
    result = {}
    mail_ids = set()

    messages = self.browse(cr,SUPERUSER_ID,ids)
    for mail in messages:
      if mail.model == 'crm.helpdesk':
        mail_ids.add(mail.res_id)

    crmhelp_obj = self.pool.get('crm.helpdesk')
    crm_lookup = {}

    # We don't simply dump the mail_ids into the browse since 
    # some of the mail_ids don't actually exist! we have to do a 
    # first pass to ensure that the crm browse objects are legit 
    # (otherwise the line crm.section_id.id kaks)
    existing_ids = crmhelp_obj.search(cr,SUPERUSER_ID,[('id','in',list(mail_ids))])
    for crm in crmhelp_obj.browse(cr,SUPERUSER_ID,existing_ids):
      crm_lookup[crm.id] = crm.section_id.id

    for mail in messages:
      if mail.model == 'crm.helpdesk':
        result[mail.id] = crm_lookup.get(mail.res_id,None)
      else:
        result[mail.id] = None

    return result

  _columns = {
    'section_id': fields.function(
                    _section_id_fnct, 
                    # type='integer', 
                    type='many2one', 
                    relation='crm.case.section',
                    store=True,
                    readonly=True,
                    string="Sales Team",
                    help='Sales team to which Case belongs to.\
                           Define Responsible user and Email account for mail gateway.'
                  )
  }



