from osv import fields, osv
import time
import pooler



class wizard_exchange_recalc(osv.osv_memory):
  _name = 'wizard.exchange.recalc'
  _description = 'Recalculate Exchange Rates'
  _columns = {
        'move_id': fields.many2one(
                        'account.move',
                        'Account Move' ),
  }
  _defaults = {
        'move_id': lambda s, c, u, ctx: ctx.get('active_id'),
  }

  def update_lines(obj, cr, uid, ids, context=None):
      am_obj = obj.pool.get('account.move')
      aml_obj = obj.pool.get('account.move.line')

      for wiz_rec in obj.browse(cr,uid,ids,context):
        src_am_rec = wiz_rec.move_id
        src_am_id = src_am_rec.id

        # Set the date across all the account move lines 
        # aml = account.move.line
        # Then recalculate all the credit/debit values if amount_currencies 
        # are found.
        for aml_rec in src_am_rec.line_id:
            aml_update = {}

            if aml_rec.amount_currency:
                res = aml_obj.compute_from_currency_amount(cr,uid,
                                                    aml_rec.account_id.id,
                                                    aml_rec.currency_id.id,
                                                    aml_rec.date,
                                                    aml_rec.amount_currency)
                if res:
                    aml_update['credit'] = res['credit']
                    aml_update['debit']  = res['debit']

            aml_obj.write(cr,uid,[aml_rec.id],aml_update,context)
      return {}

