# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2012 Zaber Inc. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import MySQLdb
from tools import config

#----------------------------------------------------------
# External Database Configuration module
# db_external
#----------------------------------------------------------

def conn_data_exists(name):
    return config.get('external_'+name+'_database',False)

def conn_get(name):
    """ Return a DB-API object for named database connection

    Provide this function a reference name and the system will fetch, 
    initialize, and return a database handle. This is not a OpenERP database
    handle, however so none of that nice ORM stuff will apply
    """

    # do we actually have login information?
    if not conn_data_exists(name):
        print "Server configuration has not been setup for database: " + name
        print "Please define:"
        print " - " + 'external_'+name+'_host'
        print " - " + 'external_'+name+'_user'
        print " - " + 'external_'+name+'_password'
        print " - " + 'external_'+name+'_port'
        print " - " + 'external_'+name+'_database'
        return

    try:
        db_api_obj = MySQLdb.connect( 
            host   = config['external_'+name+'_host'],
            user   = config['external_'+name+'_user'],
            passwd = config['external_'+name+'_password'],
            port   = int(config['external_'+name+'_port']),
            db     = config['external_'+name+'_database'],
            use_unicode = True,
            )

    except MySQLdb.Error, e:
        print "Error loading %s: %d: %s" % (name, e.args[0], e.args[1])
        return

    return db_api_obj

