# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2013 Zaber Technologies Inc. (<http://zaber.com>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from .. import data_push
import pdb

class zerp_fedex_integration_wiz_data_push(osv.osv_memory):
    _name = 'zerp.fedex.integration'
    _description = ''
    _columns = {
        'picking_id': fields.many2one(
                        'stock.picking',
                        'Delivery Order' ),
        'picking_name': fields.related(
            'picking_id',
            'name',
            type='char',
            readonly=True,
            string='Name'),
    }
    
    def _get_picking_name(self, cr, uid, context):
        picking_id = context and context.get('active_id')
        if not picking_id:
            return 'PACKX'
        
        picking = self.pool.get('stock.picking').browse(cr, 
                                                        uid, 
                                                        picking_id, 
                                                        context=context)
        return picking.name

    _defaults = {
        'picking_id': lambda s, c, u, ctx: ctx['active_id'],
        'picking_name': _get_picking_name,
    }


    def data_push(self, cr, uid, ids, context=None):
        rec = self.browse(cr,uid,ids[0])
        data_push.data_push(cr,uid,rec.picking_id,context)
        return {}



