from osv import osv

class procurement_order(osv.osv):
    _inherit = "procurement.order"

    LOCATION_CUSTOMER_ID = 8
    DEBUG = 0

    def _check_make_to_stock_product(self, cr, uid, procurement, context=None):
        # The following awkward syntax is to reduce the number of indents AND
        # ensure that we call the super classes' version of the function
        # whenever we can
        if not procurement.move_id:
            return super(procurement_order,self)._check_make_to_stock_product(
                                                    cr,uid,procurement,context)

        if (procurement.move_id.state in ('done','assigned','cancel')):
            return super(procurement_order,self)._check_make_to_stock_product(
                                                    cr,uid,procurement,context)

        move_rec = self.pool.get('stock.move').browse(
                                                  cr,uid,[procurement.move_id.id],context
                                                  )[0]

        # If the destination isn't the Customer, we continue up the inheritance
        if move_rec.location_dest_id.id != self.LOCATION_CUSTOMER_ID:
            return super(procurement_order,self)._check_make_to_stock_product(
                                                    cr,uid,procurement,context)

        # So this item is going to a customer. We force the check to fail.
        if self.DEBUG:
            f = open("/tmp/_check_make_to_stock_product.txt","a")
            f.write("\n------------------["+str(procurement.id)+"]\n")
            f.write("Product: "+procurement.product_id.default_code+" "+str(repr(procurement.product_id.name))+"\n")
            f.write("ID: "+str(procurement.move_id.id)+"\n")
            f.write("From: "+str(move_rec.location_id.name)+"\n")
            f.write("To: <"+str(move_rec.location_dest_id.id)+"> "+str(move_rec.location_dest_id.name)+"\n")
            f.close()

        cr.execute(
            'select count(id) from stock_warehouse_orderpoint where product_id=%s', 
            (procurement.product_id.id,))
        if not cr.fetchone()[0]:
            cr.execute(
                'update procurement_order set message=%s where id=%s', 
                ('from stock and no minimum orderpoint rule defined', 
                procurement.id))
        return False

procurement_order()

