# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Zaber Technologies Inc. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import math
from report import report_sxw
from osv import osv
import pooler

class Proforma(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(Proforma, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'delay_days': self.delay_days,
            'combined_lines': self.combined_lines
        })

    def delay_days(self,delay):
        return int(math.ceil(delay))
    
    def combined_lines(self, order):
        order_obj = pooler.get_pool(self.cr.dbname).get('sale.order')
        return order_obj._combined_lines(order, shouldValidate=True)

report_sxw.report_sxw(
        'report.zerp.proforma', 
        'sale.order',
        'addons/zerp_proforma/report/proforma.rml', 
        parser=Proforma)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

