# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Zaber Technologies Inc. All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from lxml import etree
import time
import math
from report import report_sxw
from osv import osv

class Layout(report_sxw.rml_parse):

    def _add_header( self, rml_dom, header = 1 ):
        return True
        rml_head =  self.rml_header
        head_dom = etree.XML(rml_head)
        for tag in head_dom:
            found = rml_dom.find('.//'+tag.tag)
            if found is not None and len(found):
                if tag.get('position'):
                    found.append(tag)
                else :
                    found.getparent().replace(found,tag)
        return True

    def __init__(self, cr, uid, name, context):
        super(Layout, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
        })
        self.rml_header = '''
<header>
  <pageTemplate>
    <frame id="first" x1="1.3cm" y1="2.5cm" height="21.2cm" width="19.0cm"/>
    <pageGraphics>

      <setFont name="Helvetica" size="5"/>
      <fill color="black"/>
      <stroke color="grey"/>
        '''
        for y in range(29*2):
            yo = y / 2.0
            self.rml_header += "<lines>"
            self.rml_header += "0.0cm %.01fcm 23.0cm %.01fcm" % ( yo, yo )
            self.rml_header += "</lines>\n"
            self.rml_header += """<drawString x="%.03fcm" y="%.03fcm">y%.01f</drawString>\n""" %  (1.05,yo-0.19,yo)
            self.rml_header += """<drawString x="%.03fcm" y="%.03fcm">y%.01f</drawString>\n""" % (10.05,yo-0.19,yo)
            self.rml_header += """<drawString x="%.03fcm" y="%.03fcm">y%.01f</drawString>\n""" % (20.05,yo-0.19,yo)

        for x in range(23*2):
            xo = x / 2.0
            self.rml_header += "<lines>"
            self.rml_header += "%.01fcm 0.0cm %.01fcm 28.0cm\n" % ( xo, xo )
            self.rml_header += "</lines>\n"
            self.rml_header += """<drawString x="%.03fcm" y="%.03fcm">x%.01f</drawString>\n""" % (xo+0.05,1.05,xo)
            self.rml_header += """<drawString x="%.03fcm" y="%.03fcm">x%.01f</drawString>\n""" % (xo+0.05,13.05,xo)
            self.rml_header += """<drawString x="%.03fcm" y="%.03fcm">x%.01f</drawString>\n""" % (xo+0.05,27.05,xo)

        self.rml_header += '''

        <drawString x="1.55cm" y="24.5cm">
          Eleventy Billion
        </drawString>

    </pageGraphics>

  </pageTemplate>
</header>

        '''

        print self.rml_header
        self.context = context


report_sxw.report_sxw(
        'report.zerp.report.layout', 
        'account.invoice',
        'addons/zerp_proforma/report/layout.rml', 
        parser=Layout)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

