from osv import fields, osv

class zerp_stock(osv.osv_memory):
    _name = 'zerp.stock'
    _description = 'ZERP Stock'
    
    _columns = {'stock_date': fields.date(
                    'Tabulate for Date',
                    help='Calculate the inventory value for this date at 23:59:59',
                    required=False)}
    
    _defaults = {'stock_date': fields.date.context_today}

    def create_report(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        data = self.read(cr, uid, ids)[0]
        datas = {'ids': context.get('active_ids',[]),
                 'model': 'stock.location',
                 'form': data}
        return {'type': 'ir.actions.report.xml',
                'report_name': 'zerp.report.stock',
                'datas': datas}

zerp_stock()
