from osv import fields
from osv import osv


class res_partner (osv.osv):
    _inherit = 'res.partner'

    def sanity_check(self, cr, uid, context=None):
        self.sanity_check_fast(cr, uid, context)
        return 0

    def sanity_check_fast(self, cr, uid, context):
        ''' A set of fast sanity checks
        '''
        self.supplier_pricelists(cr, uid, context)
        self.supplier_contacts(cr, uid, context)
        return

    def supplier_contacts(self,cr,uid,context):
        case_id = self.pool.get('crm.helpdesk').sanity_test_create_stub_case(cr,uid,context,
        "Found suppliers without a contact address",
        ''' Supplier partners need at least one contact or you get procurement exceptions
        ''',
        'res_partner_supplier_contacts')

        supplier_ids = self.search(cr,uid,[('supplier','=',True)])

        if not supplier_ids: return

        problem_writeup = ("The following Partners (Suppliers) do not have a contact listed, " +
                          "without a name, phone, mobile, fax, email or street address. " +
                          "Procurement exceptions occur Without at least one contact :\n\n")
                          
        problem_supplier_count = 0

        for supplier in self.browse(cr,uid,supplier_ids):
            good = False
            for contact in supplier.address:
                if contact.name or contact.street or contact.phone or contact.mobile or contact.fax or contact.email:
                    good = True
                    break
            if good: continue
            problem_writeup += "%i: %s\n" % (supplier.id, supplier.name)
            problem_supplier_count += 1

        if not problem_supplier_count:
            return

        # now that we've finished documenting the problem let's notify the 
        # appropriate users
        self.pool.get('crm.helpdesk').sanity_test_log(
                  cr, uid, context,
                  case_id,
                  problem_writeup
              )

        return


    def supplier_pricelists(self,cr,uid,context):
        case_id = self.pool.get('crm.helpdesk').sanity_test_create_stub_case(cr,uid,context,
        "Found suppliers without a purchase pricelist",
        ''' This is a stub to track incidents of suppliers that do not have a Purchase Pricelist.
            Without a purchase pricelist, the mrp_scheduler will crash.
        ''',
        'res_partner_supplier_pricelists')

        supplier_ids = self.search(cr,uid,[('supplier','=',True)])

        if not supplier_ids:
            return # no weirdness to worry about

        problem_writeup = "The following Partners (Suppliers) do not have a pricelist:\n\n"
        problem_supplier_count = 0
        for supplier in self.browse(cr,uid,supplier_ids):
            if not supplier.property_product_pricelist_purchase.id:
                problem_writeup += "%i: %s\n" % (supplier.id, supplier.name)
                problem_supplier_count += 1

        if not problem_supplier_count:
            return

        # now that we've finished documenting the problem let's notify the 
        # appropriate users
        self.pool.get('crm.helpdesk').sanity_test_log(
                  cr, uid, context,
                  case_id,
                  problem_writeup
              )

        return

res_partner()
