from osv import fields
from osv import osv
from tools import config

class sale_order(osv.osv):
    _inherit = 'sale.order'

    def sanity_check(self, cr, uid, context=None):
        self.sanity_check_fast(cr, uid, context)
        return 0

    def sanity_check_fast(self, cr, uid, context):
        ''' A set of fast sanity checks
        '''
        self.sale_shipping_except(cr,uid,context)

    def sale_shipping_except(self,cr,uid,context):
        case_id = self.pool.get('crm.helpdesk').sanity_test_create_stub_case(cr,uid,context,
        "Found Sales Orders in a state of Shipping Exception",
        """ This is a stub to track incidents where Sales Orders are found with the status "Shipping Exception". 
        """,
        'sale_shipping_exception')

        sale_ids = self.search(cr,uid,[('state','=','shipping_except')])
        if not sale_ids: return # okay, no problems

        problem_writeup = "The following Sales Orders have been marked as having an Shipping Exception:\n\n";
        for sale in self.browse(cr,uid,sale_ids):
            problem_writeup += "%i - %s - %s\n" % (sale.id,sale.name,sale.partner_id.name)
        problem_writeup += "\n\n";

        # now that we've finished documenting the problem let's notify the 
        # appropriate users
        self.pool.get('crm.helpdesk').sanity_test_log(
                  cr, uid, context,
                  case_id,
                  problem_writeup
              )

sale_order()
