# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2013 Zaber Technologies Inc. (<http://zaber.com>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

solr_models = ('crm.helpdesk','product.product','res.partner')

class zerp_solr_wiz_reindex(osv.osv_memory):
    _name = 'zerp.solr.wiz.reindex'
    _description = 'Zerp Solr Reindex Wizard'
    
    _columns = {'reindex_all': fields.boolean(
                    'Reindex All',
                    help='Reindex all records in database',
                    required=False),
              }

    def reindex(self, cr, uid, ids, context=None):

        models = []
        if self.browse(cr,uid,ids[0],context).reindex_all: 
            models = solr_models
        elif context['target_model'] in solr_models:
          models = [context['target_model']]

        for model in models:
            obj = self.pool.get(model)
            obj.solr_reindex(cr,uid,context)

        return {}

