# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2012 Zaber Technologies Inc. (<http://zaber.com>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import netsvc
from osv import fields,osv,orm
import utils
from datetime import datetime


@utils.add_solr_support(autoupdate=False)
class product_product(osv.osv):
    _inherit = "product.product"

    def solr_record(self,cr,prod,solr_rec):
        description_list = []
        description_list.append(prod.product_tmpl_id.description)
        description_list.append(prod.notes)
        for seller in prod.seller_ids:
            description_list.append(seller.product_code)
            description_list.append(seller.product_name)
        description = "\n".join(filter(None,description_list))
        solr_rec.update({
          'name': prod.product_tmpl_id.name,
          'description': description,
          'code': prod.default_code,
          'status': prod.product_tmpl_id.state,
          'category': prod.categ_id.complete_name,
          'cat': prod.categ_id.complete_name,
          'harmonized_code': prod.categ_id.harmonized_code,
          'country': prod.categ_id.origin_country_id.code,
          'country_name': prod.categ_id.origin_country_id.name,
          'responsible': prod.product_tmpl_id.product_manager.name,
          'supplier': prod.default_partner_name,
          'manager': prod.product_tmpl_id.product_manager.name,
        })
        if prod.revision:
          solr_rec['revision'] = prod.revision
        return solr_rec
