from osv import osv

class account_invoice(osv.osv):
    _inherit = 'account.invoice'
    
    def invoice_open(self, cr, uid, ids, context=None):
        return self._check_warning(cr, uid, ids, 'invoice_open', context)
    
    def invoice_proforma2(self, cr, uid, ids, context=None):
        return self._check_warning(cr, uid, ids, 'invoice_proforma2', context)
    
    def _check_warning(self, cr, uid, ids, signal, context):
        """ Check if an invoice needs to display a warning. If so, create
        the warning and ask for it to be displayed. If not, trigger the
        confirmation work flow. 
        """
        id, = ids
        invoice = self.browse(cr, uid, id, context)

        # We only care about taxes when it's a customer invoice and
        # the customer is in our country.
        company_country_id = (
            invoice.company_id.partner_id.address[0].country_id.id)
        partner_country_id = invoice.address_invoice_id.country_id.id
        are_taxes_needed = (company_country_id == partner_country_id and 
                            invoice.type.startswith('out_'))
        missing_taxes = False
        if are_taxes_needed:
            # So do all the line items have taxes associated with it?
            for line in invoice.invoice_line:
                if not line.invoice_line_tax_id:
                    missing_taxes = True
                    break
        
        return self.pool.get('confirm.warning').check_warning(
            cr, 
            uid, 
            'Confirm Invoice', 
            invoice.partner_id.name, 
            invoice.partner_id.invoice_warn_msg,
            self._name,
            id,
            signal,
            invoice.partner_id.invoice_warn, 
            missing_taxes, 
            context)

account_invoice()
