from osv import osv
from tools.translate import _

class purchase_order(osv.osv):
    _inherit = 'purchase.order'
    
    def purchase_confirm(self, cr, uid, ids, context=None):
        """ Check if an invoice needs to display a warning. If so, create
        the warning and ask for it to be displayed. If not, trigger the
        confirmation work flow. 
        """
        id, = ids
        purchase = self.browse(cr, uid, id, context)
        partner_name = purchase.partner_id.name
        warning_level = purchase.partner_id.purchase_warn
        message = purchase.partner_id.purchase_warn_msg
        
        #TODO: Purchase order lines require product now?
        
        # Don't allow invoice from picking when there are no 
        # stockable products on a purchase order or more 
        # than warehouse.po_max_lines_unpickable (default 2) 
        # unpickable products.
        if purchase.invoice_method == 'picking' and purchase.order_line:
            lines = len(purchase.order_line)
            lines_unpickable = 0
            for line in purchase.order_line:
                if line.product_id.type not in ('product', 'consu'):
                    lines_unpickable += 1
            if lines == lines_unpickable:
                warning_level = 'block'
                partner_name = None
                message = _("No stockable items ordered, yet Invoicing " +
                            "Control on Delivery & Invoicing tab is set to " +
                            "'Based on Receptions'")
            elif lines_unpickable > purchase.warehouse_id.po_max_lines_unpickable:
                warning_level = 'block'
                partner_name = None
                message = _("More than %i items are non-stockable, yet " +
                            "Invoicing Control on Delivery & Invoicing tab " +
                            "is set to 'Based on Receptions'") % \
                            purchase.warehouse_id.po_max_lines_unpickable
        
        return self.pool.get('confirm.warning').check_warning(
            cr, 
            uid, 
            'Confirm Purchase Order', 
            partner_name, 
            message,
            self._name,
            id,
            'purchase_confirm',
            warning_level, 
            context=context)

purchase_order()
